#!/bin/bash

#
# This is just a script to compile and run all of the files
#

FILE=$1
QUANDLEDIR=quandles$FILE
BINDIR=bin$FILE

OPT='-march=native -mtune=native -O3 -fomit-frame-pointer'

# set the knot
K=199

#gcc $OPT color_mt.c        -lpthread -DQ$Q -DK$K -o bin/'q'$Q'k'$K.pthread
#printf "pthread: "; bin/'q'$Q'k'$K.pthread

# get the number of quandles
NRQUANDLES=$(/bin/ls -1 $QUANDLEDIR/q*.c|wc -l);

# clear the log
echo -n > log.$FILE


# compile
    for ((Q=1;Q<=NRQUANDLES;Q++)); do
        echo 'compiling '$Q' ...'
        gcc $OPT color_mt.c        -lpthread -DQ$Q -DK$K -o $BINDIR/'q'$Q'k'$K.pthread.$FILE
        gcc $OPT color_mt.c -DDUAL -lpthread -DQ$Q -DK$K -o $BINDIR/'q'$Q'k'$K.pthread.dual.$FILE
    done

# actually perform the knot coloring computations
    for ((Q=1;Q<=NRQUANDLES;Q++)); do
        printf "quandle %d\n" $Q;
        printf "normal: "              >> log.$FILE
        $BINDIR/'q'$Q'k'$K.pthread.$FILE       >> log.$FILE
        printf "dual  : "              >> log.$FILE
        $BINDIR/'q'$Q'k'$K.pthread.dual.$FILE  >> log.$FILE
        echo                           >> log.$FILE
    done


#for ((Q=1;Q<=NRQUANDLES;Q++)); do
#    printf "normal: "              >> log.1
#    bin/'q'$Q'k'$K.pthread.1       >> log.1
#    printf "dual  : "              >> log.1
#    bin/'q'$Q'k'$K.pthread.dual.1  >> log.1
#    echo                           >> log.1
#done


